#
# Licensed Materials - Property of IBM
# Rational ClearQuest
# (C) Copyright IBM Corp. 2013.  All Rights Reserved
# US Government Users Restricted Rights
# Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
#
# Script for deploying BIRT to WebSphere Application Server

import sys
from com.ibm.rational.clearquest.reports.launcher.birt.deploy import DeploymentDescriptorUpdater

birtRuntimeFile = sys.argv[0]
print 'Start-Installing BIRT ...', birtRuntimeFile


AdminApp.install(birtRuntimeFile,'[-appname birt_war -contextroot /birt -MapWebModToVH [[ "Eclipse BIRT Report Viewer" ' + birtRuntimeFile + ',WEB-INF/web.xml default_host ]]]' ) 


app = AdminConfig.getid('/Deployment:birt_war/')
depObject = AdminConfig.showAttribute(app, 'deployedObject')
classldr = AdminConfig.showAttribute(depObject, 'classloader')


AdminConfig.modify(classldr, [['mode', 'PARENT_LAST']])
AdminConfig.modify(depObject, [['warClassLoaderPolicy', 'SINGLE']])


print 'Setting WORKING_FOLDER_ACCESS_ONLY to false in the BIRT web.xml'
ddupdater = DeploymentDescriptorUpdater()
ddupdater.updateAndSaveDeploymentDescriptorFromWAR (birtRuntimeFile,"cq_birt_web.xml")

print 'Replacing BIRT web.xml in deployed WebSphere application'
AdminApp.update('birt_war', 'file', '[-operation update -contents cq_birt_web.xml -contenturi ' + birtRuntimeFile + '/WEB-INF/web.xml]')
print 'Saving the WebSphere configuration'
AdminConfig.save()

# Start the birt_war application
node = AdminControl.getNode()
cell = AdminControl.getCell()
appManager = AdminControl.queryNames('cell=' + cell +',node=' + node + ',type=ApplicationManager,process=server1,*')
print 'Starting birt_war application ...'
AdminControl.invoke(appManager,'startApplication','birt_war')


print 'Finish-Installing BIRT ...', birtRuntimeFile